=== modified file 'daemons/poppy-sftp.tac'
--- daemons/poppy-sftp.tac	2011-05-10 07:39:36 +0000
+++ daemons/poppy-sftp.tac	2011-05-10 13:56:21 +0000
@@ -111,7 +111,7 @@
 execute_zcml_for_scripts()
 
 # Set up the GPGHandler job
-gpgHandlerJob = GPGHandlerConfigResetJob()
+GPGHandlerConfigResetJob().setServiceParent(application)
 
 # Service that announces when the daemon is ready
 readyservice.ReadyService().setServiceParent(application)

=== modified file 'lib/lp/poppy/tests/test_twistedconfigreset.py'
--- lib/lp/poppy/tests/test_twistedconfigreset.py	2011-05-10 07:39:36 +0000
+++ lib/lp/poppy/tests/test_twistedconfigreset.py	2011-05-10 13:56:21 +0000
@@ -19,8 +19,13 @@
         # Does the gpghandler job get setup correctly.
 
         job_instance = GPGHandlerConfigResetJob()
+        job_instance.startService()
         self.assertIsNot(None, job_instance._gpghandler_job)
         self.assertTrue(job_instance._gpghandler_job.running)
 
         # It should be scheduled for every 12 hours.
         self.assertEqual(12 * 3600, job_instance._gpghandler_job.interval)
+
+        # We should be able to stop the job.
+        job_instance.stopService()
+        self.assertFalse(job_instance._gpghandler_job.running)

=== modified file 'lib/lp/poppy/twistedconfigreset.py'
--- lib/lp/poppy/twistedconfigreset.py	2011-05-10 07:39:36 +0000
+++ lib/lp/poppy/twistedconfigreset.py	2011-05-10 13:56:21 +0000
@@ -8,8 +8,7 @@
     'GPGHandlerConfigResetJob',
     ]
 
-import atexit
-
+from twisted.application.service import Service
 from twisted.internet import task
 from twisted.internet.error import AlreadyCancelled
 
@@ -19,14 +18,18 @@
 from canonical.launchpad.interfaces.gpghandler import IGPGHandler
 
 
-class GPGHandlerConfigResetJob:
+class GPGHandlerConfigResetJob(Service):
     """Manages twisted job to touch the files in the gpgconfig directory."""
-    def __init__(self):
+
+    def startService(self):
         self._gpghandler_job = None
-        # stop the GPGHandler job on normal termination.
-        atexit.register(self._stopGPGHandlerJob)
         # start the GPGHandler job
         self._scheduleGPGHandlerJob()
+        Service.startService(self)
+
+    def stopService(self):
+        self._stopGPGHandlerJob()
+        Service.stopService(self)
 
     def _scheduleGPGHandlerJob(self, touch_interval=12 * 3600):
         # Create a job to touch the GPGHandler home directory every so often

